\XPL.XPL
\XPLV4D MAY 80
\
\	COPYRIGHT P.J.R.BOYLE. 1977,78,79,80

\This program is free software; you can redistribute it and/or modify it under
\the terms of the GNU General Public License version 2 as published by the
\Free Software Foundation.
\This program is distributed in the hope that it will be useful, but WITHOUT
\ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
\FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
\details.
\You should have received a copy of the GNU General Public License along with
\this program (in the file LICENSE.TXT); if not, write to the Free Software
\Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

\REVISIONS:
\2015-12-07 e.s. Multi-dim array support. OWN arrays removed. I2L code no
\ longer V4 compatible.
\2015-11-23 e.s. Add | ~ >> << ->> other char to downto and or xor port func
\ ffunc condition string dbl-backslash. Fix unary precedence. Increase max
\ symbols, line length. 16-char names. Multiple case labels. Update Define.
\ Exit takes optional expression. Constant expressions.
\2015-10-01 e.s. IBM PC cross-compiler version. Uses file I/O from X65.XPL

\THESE ARE THE REQUIRED MACHINE LANGUAGE FUNCTIONS:
code
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
CHIN=7,		CHOUT=8,	CRLF=9,		INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16;

\%%% IBM INTRINSICS
code
TRAP=17,	GETERR=22,	FSET=24,	FOPEN=29,
FCLOSE=32,	GETREG=35,	BLIT=36;

\%%% VARIABLES FOR IBM DISKIO %%%%

int
	SYSINF,	\POINTER SYSTEM TO INFO
	INHAND,	\INPUT HANDLE
	OUTHAND;\OUTPUT HANDLE

\RESERVED WORD HASHES\
define
ADRSYM=$88E4,	BEGSYM=$84C7,	CASEYM=$8053,	CODSYM=$8184,
DEFSYM=$9CC6,	DOSYM=$0CEF,	ELSEYM=$99F3,	ENDSYM=$99A4,
FALSYM=$944C,	FORSYM=$9592,	FPRSYM=$9672,
GESYM=$0C85,	GETSYM=$90D4,	IFSYM=$0D46,	INTSYM=$A9B4,
LESYM=$0DE5,	LOOPYM=$BD8F,	NOTSYM=$B594,
OFSYM=$0D86,	PROCYM=$CE2F,	REPSYM=$C4D0,	RETSYM=$C4D4,
THENYM=$DD65,	TRUSYM=$DE35,	UNTSYM=$D9B4,	WHILYM=$D169,
QUITYM=$CAC9,	EXTNYM=$9B74,	EXITYM=$9B69,	CHARYM=$8161,
OTHSYM=$B2E8,	LSLSYM=$BE0C,	LSRSYM=$BE92,	ASRSYM=$8A12,
TOSYM=$0EEF,	DOWNYM=$9D97,	ANDSYM=$89A4,	ORSYM=$0D92,
XORSYM=$ED92,	PORTYM=$CD92,	FUNSYM=$96CE,	FFUNYM=$94B5,
CONSYM=$818E,	STRSYM=$C2F2,

\OTHER CONSTANTS
	CODOFF=64,	\OFFSET FOR INTRINSIC ROUTINES
	SYMAX=1000,	\SIZE OF THE SYMBOL TABLE
	EMTPTR=-1,	\EMPTY SYMBOL POINTER
	BOXNUM=256,	\NUMBER OF BOXES (POWER OF 2)
	HASHMSK=$FF,	\HASH MASK (BOXNUM-1)
	SIGCHAR=16,	\NO. OF SIGNIFICANT CHARS IN AN IDENT
	QUITMAX=100,	\MAXIMUM NO. OF 'QUIT'S IN A 'LOOP'

\ASCII CHARACTERS
	EOF=$1A, BEL=$07, EOL=$0A;

\CODES FOR IDENTIFIER TYPES FOR IDTYPE
define	UNDEF,		\UNDEFINED
	ADDRVAR,	\ADDRESS VARIABLE
	INVAR,		\INTEGER VARIABLE
	INCON,		\CONSTANT NAME
	INPROC,		\NORMAL PROCEDURE
	INFPROC,	\FOREWARD PROCEDURE
	INOPT,		\OPTIMIZED PROC.
	ININT,		\INTRINSIC PROC.
	INEXT;		\EXTERNAL PROC.

\CODES FOR ATOM TYPES FOR ATYPE
define	SPECIAL,	\RESERVED WORDS, FUNNY CHARS ETC.
	IDENTIFIER,	\AN IDENTIFIER
	INTCON;		\A CONSTANT

int	DEVICE,		\% DEFAULT DEVICE ARRAY.
	SRCDEV,		\SOURCE INPUT DEVICE NUMBER
	LSTDEV,		\LISTING DEVICE NUMBER
	BINDEV; 	\BINARY OUTPUT DEVICE

int	\INTEGER VARIABLES FOR ACTUAL PROCESSING
	CHAR,		\CURRENT CHARACTER BUFFER. MOST OF THE TIME
			\IT CONTAINS THE TERMINATOR OF THE CURRENT ATOM
	CASEIN,		\BOOLEAN- CASE SWITCH
	CONDITIONAL,	\FLAG: CONDITIONAL COMPILE
	STRTERM,	\FLAG: STRING TERMINATION (0=NULL, NONZERO=MSB)
	ATOM,		\PRESENT ATOM DESCRIPTOR
			\CONTAINS RESERVED WORD HASH OR THE ASCII FOR
			\A SPECIAL CHARACTER. 0 IF THE ATOM IS A
			\CONSTANT OR IDENTIFIER
	ATYPE,		\PRESENT ATOM TYPE DESCRIPTOR
	IDTYPE,		\PRESENT IDENTIFIER TYPE DESCRIPTOR
	LEV,		\LEVEL OF CURRENT IDENTIFIER
	VAL,		\VALUE OR ADDRESS OF CURRENT IDENTIFIER
	IATOM,		\VALUE OF CURRENT CONSTANT
	SYMNUM,		\NUMBER IN SYMTAB OF CURRENT IDENT
	NOSYM,		\NUMBER OF SYMBOLS IN SYMBOL TABLE
	LEVEL,		\LEVEL OF CURRENT PROCEDURE
	T,		\GENERAL TEMPORARY
	PC,		\THE RELATIVE PROGRAM COUNTER
	FIXCNT,		\COUNT OF THE NUMBER OF OUTSTANDING QUITS
	OLDPC,		\SAVE SPACE FOR PC
	OPTPROC,	\FLAG SHOWS OPTIMIZED PROC
	STKLOD,		\THE NUMBER OF PENDING STACK VALUES
	HASH;		\CURRENT IDENTIFIER HASH

address
	IDENT,		\CURRENT IDENTIFIER NAME
	SYMBOL,		\SYMBOL TABLE
	SYMTYP,		\SYMBOL TYPE DESCRIPTORS
	SYMLEV;		\SYMBOL LEVELS

\INTEGER ARRAYS:
int
	SYMVAL,		\SYMBOL VALUES OR ADDRESSES
	SYMPNT,		\SYMBOL LIST LINKAGE POINTERS
	BOX,		\HASH BOXES (SYMBOL LIST HEADERS)
	FIXES;		\QUIT FIXES STILL OUTSTANDING


proc	ERROR; int N;	\SEND ERROR MESSAGE TO THE TV
int	ERR,CH,I;
char	STRING;
def	MAXERR=74;	\MAXIMUM ERROR NUMBER
begin
ERR:=RESERVE((MAXERR+1)*2);
for I:=0,MAXERR do ERR(I):="?";	\UNUSED ERROR NOS. ="?"

ERR(1):="TOO MANY VARIABLES";
ERR(3):="TOO MANY NAMES";
ERR(4):="TOO MANY QUITS";
ERR(5):="PROCEDURES NESTED TOO DEEP";
ERR(6):="OUT OF RANGE";
ERR(7):=ERR(6);		\FOR INTRINSIC DECLARATIONS
ERR(10):="UNDECLARED NAME";
ERR(11):="NAME ALREADY DECLARED";
ERR(20):="ILLEGAL START OF STATEMENT";	\IN "ASSIGN"
ERR(21):="BAD ASSIGNMENT";
ERR(22):="THEN EXPECTED";
ERR(23):="DO EXPECTED";
ERR(24):="TO/DOWNTO EXPECTED";
ERR(26):="ILLEGAL FACTOR";	\UNRECOGNIZABLE SPECIAL FACTOR
ERR(27):="STATEMENT STARTING WITH CONSTANT "; \IN "ASSIGN"
ERR(28):="UNTIL EXPECTED";
ERR(29):="OTHER EXPECTED";
ERR(30):="ELSE EXPECTED";
ERR(33):="INTEGER EXPECTED";	\IN A 'FOR' STATEMENT
ERR(38):="> EXPECTED";		\ASR ->>
ERR(39):="( EXPECTED";
ERR(40):="= EXPECTED";
ERR(41):="; EXPECTED";
ERR(42):="BAD CONSTANT";	\IN "GETCON"
ERR(43):="VARIABLE EXPECTED";	\FOR AN 'ADDR' OPERATOR
ERR(44):=") EXPECTED";
ERR(45):="NAME EXPECTED";
ERR(48):="OF EXPECTED";
ERR(49):=": EXPECTED";
ERR(50):="] EXPECTED";
ERR(51):="NO ARGS DECLARED";
ERR(52):="STATEMENT STARTING WITH ELSE";
ERR(53):="STATEMENT STARTING WITH OTHER";
ERR(60):="UNRESOLVED QUITS";
ERR(61):="EOF EXPECTED";
ERR(62):="EOF INSIDE BLOCK";
ERR(63):="EOF INSIDE STRING";
ERR(65):="FPROC & PROC NOT SAME LEVEL";
ERR(66):="UNRESOLVED FPROC";
ERR(73):="DIVIDE BY ZERO";

CRLF(0);
if LSTDEV=8 then
	begin
	OPENI(8);
	loop
		begin
		I:=CHIN(8);
		if I=EOF then quit;
		CHOUT(0,I);
		end;
	CRLF(0);
	end;
CRLF(0);
TEXT(0,"***** ERROR "); INTOUT(0,N); TEXT(0,": ");
TEXT(0,ERR(N));
TEXT(0," *****");
CRLF(0);
CLOSE(LSTDEV);
ABORT;
end;	\ERROR


proc	GETCH;	\GET A CHARACTER FROM THE SOURCE DEVICE
\ FILTERS OUT COMMENTS
begin
CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
if CHAR=^\ then				\FILTER OUT COMMENTS
	begin
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	if CHAR=^\ then			\FILTER OUT REST OF LINE
		loop   [CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
			if CHAR=$0D\CR\ then return;
			if CHAR=EOF then return]
	else	loop   [if CHAR=$0D\CR\ then return;
			if CHAR=EOF then return;
			CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
			if CHAR=^\ then [CHAR:= ^ ; return]];
	end;

if CHAR=$27 then
	[CASEIN:= not CASEIN; CHAR:=^ ]	\SHIFT CASE
 else if CASEIN then	\SWITCH TO LOWER CASE IF CASEIN IS TRUE
	[if CHAR>=^A & CHAR<=^Z then CHAR:=CHAR+32];
end;	\GETCH


proc	GETCH_;	\GET A NON-UNDERLINE CHARACTER FROM THE SOURCE DEVICE
repeat GETCH until CHAR#^_;

\-------------------------------------------------------------------------------

fproc	CONEXPRESS;


proc	RATOM;		\READ AN ATOM
int	LEN;

begin	\RATOM
while CHAR<=$20\SPACE\ do
	begin	\SKIP SPACES, TABS, RETURNS, LF'S, & FF'S, ETC.
		\DON'T GO PAST EOF
	if CHAR=EOF then [ATYPE:=SPECIAL; ATOM:=EOF; return];
	GETCH;
	end;
case  of
CHAR>=^a & CHAR<=^z:
	begin \RESERVED WORD
        ATYPE:=SPECIAL;
        ATOM:=CHAR; GETCH;
        ATOM:=ATOM<<5|CHAR; GETCH;
	if (CHAR>=^A & CHAR<=^Z) ! (CHAR>=^a & CHAR<=^z) then
	  ATOM:=ATOM<<5|CHAR;
        while (CHAR>=^A & CHAR<=^Z) ! (CHAR>=^a & CHAR<=^z) do GETCH;
	case ATOM of
	  TRUSYM: [ATYPE:=INTCON; ATOM:=0; IATOM:=true];
	  FALSYM: [ATYPE:=INTCON; ATOM:=0; IATOM:=false];
	  CONSYM: begin
		  RATOM;
		  CONEXPRESS;
		  CONDITIONAL:= IATOM;
		  while ATOM=^; do RATOM;		\EAT SEMI, IF ANY
		  loop	begin				\EAT ATOMS UNTIL COND=TRUE
			if CONDITIONAL \#0\ then quit;
			if ATYPE=SPECIAL then
			  if ATOM=EOF then quit
			  else if ATOM=^" then	\Ignore 'con' in strings
			    begin
			    loop begin
				 CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
				 if CHAR=EOF then ERROR(63);
				 if CHAR=^^ then
					[CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR)]
				 else	if CHAR=^" then quit;
				 end;
			    GETCH;
			    end;
			RATOM;
			end;
		  end;
	  STRSYM: begin
		  RATOM;
		  CONEXPRESS;
		  STRTERM:= IATOM;
		  while ATOM=^; do RATOM;	\EAT SEMICOLON, IF ANY
		  end
	other;
        end;

(CHAR>=^A & CHAR<=^Z) ! CHAR=^_:
	begin \IDENTIFIER
	ATYPE:=IDENTIFIER; ATOM:=0;
        LEN:=0;HASH:=0;
        while (CHAR>=^A & CHAR<=^Z) ! (CHAR>=^a & CHAR<=^z) !
		(CHAR>=^0 & CHAR<=^9) ! CHAR=^_ do
		begin
		if CHAR>=^a & CHAR<=^z then CHAR:= CHAR & $DF;	\UPPERCASE
		if LEN<SIGCHAR then
			begin
			IDENT(LEN):=CHAR;
			HASH:=HASH+CHAR;
			LEN:=LEN+1;
			end;
		GETCH;
		end;
	for LEN:=LEN,SIGCHAR-1 do
		[IDENT(LEN):=^ ; HASH:=HASH+^ ];
        HASH:=HASH&HASHMSK;
        end;

CHAR>=^0 & CHAR<=^9:
	begin \CONSTANT
	ATYPE:=INTCON; ATOM:=0;
	IATOM:=0;
	while CHAR>=^0 & CHAR<=^9 do
	[IATOM:=IATOM*10+CHAR-^0; GETCH_];
	end;

CHAR=^$:
	begin \HEXADECIMAL CONSTANT
	ATYPE:=INTCON; ATOM:=0;
        GETCH_;
        IATOM:=0;
        loop begin
		if CHAR>=^0 & CHAR<=^9 then
		        IATOM:=IATOM*16+CHAR-^0
	         else if (CHAR>=^A & CHAR<=^F) ! (CHAR>=^a & CHAR<=^f) then
		        IATOM:=IATOM*16+(CHAR&$DF)-^A+10
		 else quit;
		GETCH_;
		end;
        end;

CHAR=^%:
	begin \UNSIGNED BINARY INTEGER
	ATYPE:=INTCON; ATOM:=0;
	GETCH_;
	IATOM:=0;
	while CHAR>=^0 & CHAR<=^1 do
	[IATOM:=IATOM*2+CHAR-^0; GETCH_];
	end;

CHAR=^^:
	begin \META CHARACTER = INTEGER CONSTANT
	ATYPE:=INTCON; ATOM:=0;
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
\**	if CHAR <$20 ! CHAR=$7F then WARNING(3);
	IATOM:=CHAR;
	GETCH;
	end;

CHAR=^":
	begin \SPECIAL CHARACTER
	ATYPE:=SPECIAL; ATOM:=CHAR;
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	end

 other
	begin
	ATYPE:=SPECIAL;		\SPECIAL CHARACTER
	ATOM:=CHAR;
	GETCH;
	case CHAR of
	  ^=:	case ATOM of
		  ^::	[GETCH; ATOM:=GETSYM];
		  ^>:	[GETCH; ATOM:=GESYM];
		  ^<:	[GETCH; ATOM:=LESYM]
		other;
	  ^<:	[if ATOM = ^< then [GETCH; ATOM:= LSLSYM]];
	  ^>:	begin
		if ATOM = ^> then [GETCH; ATOM:= LSRSYM]
		else if ATOM = ^- then
			[GETCH;
			if CHAR#^> then ERROR(38);
			GETCH;
			ATOM:= ASRSYM];
		end
	other;
	end;
end;	\RATOM


proc	HEXB(I);
int	I;

    proc	PHEX(I);
    int		I;
    begin
    if I<=9 then I:=I+^0 else I:=I+^7;
    CHOUT(BINDEV,I);
    end;

begin \HEXB
PHEX((I&$FF)/16);
PHEX(REM(0));
end;	\HEXB


proc	HEXW(I);
int	I;
begin
HEXB(SWAP(I));HEXB(I)
end;


proc	GEN; int OP,LEV,VAL,CL;	\GENERATE OP CODE
begin
\THE ENCODING OF THE CLASS, CL IS A 4 BIT BINARY CODE...
\0:=OP CODE ONLY, 1 BYTE
\2:=OP WITH ONE BYTE VALUE
\3:=OP WITH VALUE, 3 BYTES
\7:=OP WITH ADDRESS, 3 BYTES
\10:=OP WITH LEVEL AND ONE BYTE OFFSET (IN VAL)
\15:=OP WITH LEVEL AND ADDRESS, 4 BYTES
if PC#OLDPC then [CRLF(BINDEV);CHOUT(BINDEV,^;);HEXW(PC)];
if OP=1 & LEV=0 & VAL>=0 & VAL<$100 then  \SHORT GLOBAL LOAD (MAGIC OPCODE)
	[HEXB(VAL/2!$80); PC:=PC+1]
else 	begin
	HEXB(OP); PC:=PC+1;
	if CL&8 then [HEXB(LEV); PC:=PC+1];
	if CL&4 then [CHOUT(BINDEV,^*); HEXW(VAL); PC:=PC+2;]
	else	begin
		if CL=10 then [HEXB(VAL); HEXB(SWAP(VAL)); PC:=PC+2]
		else if CL&2 then [HEXB(VAL);PC:=PC+1];
		if CL&1 then [HEXB(SWAP(VAL));PC:=PC+1];
		end;
	end;
OLDPC:=PC;
end;	\GEN


proc	FIX; int I;	\FIX FORWARD REFERENCES
begin
CRLF(BINDEV);
if PC#OLDPC then
	[CHOUT(BINDEV,^;); HEXW(PC);
	OLDPC:=PC;
	CRLF(BINDEV)];
CHOUT(BINDEV,^^); HEXW(I+1);
end;	\FIX


proc	GENIMM; \GENERATE IMM OP CODE
int	VAL;
if ABS(VAL)<128 & VAL#$8000 then
	GEN(\IMS\36,0,VAL,2)
else	GEN(\IMM\11,0,VAL,3);


proc	LOOKUP;		\LOOKUP IDENTIFIER IN SYMBOL TABLE
\INPUTS: IDENT, HASH
\OUTPUTS: IDTYPE, VAL, LEV, SYMNUM.
\IF TWO IDENTIFIERS OF THE SAME NAME ARE IN THE SYMBOL TABLE
\ THEN THE MOST RECENT ENTRY IS USED.
int	I,K,PNTR;
begin
PNTR:=BOX(HASH);
loop	begin
	if PNTR=EMTPTR then [IDTYPE:=UNDEF; quit];
	I:=0; K:=PNTR;
	while IDENT(I)=SYMBOL(K) & I<SIGCHAR do
		[I:=I+1; K:=K+SYMAX];
	if I=SIGCHAR then	\FOUND
		[IDTYPE:=SYMTYP(PNTR);
		VAL:=SYMVAL(PNTR);
		LEV:=SYMLEV(PNTR);
		SYMNUM:=PNTR;		\(FOR FORWARD PROC)
		quit];
	PNTR:=SYMPNT(PNTR);
	end;
end;	\LOOKUP


proc	INSERT; int STYP,SLEV,SVAL;
\INSERT THE CURRENT IDENTIFIER INTO THE SYMBOL TABLE
\INPUTS:  STYP, SLEV, SVAL, IDENT, HASH, NOSYM, SYMBOL, & BOX.
int	I,K;
begin
LOOKUP;
if IDTYPE#UNDEF then if LEV=LEVEL then ERROR(11);

if NOSYM>=SYMAX then ERROR(3);
K:=NOSYM;
for I:=0,SIGCHAR-1 do [SYMBOL(K):=IDENT(I); K:=K+SYMAX];
SYMTYP(NOSYM):=STYP;
SYMLEV(NOSYM):=SLEV;
SYMVAL(NOSYM):=SVAL;

SYMPNT(NOSYM):=BOX(HASH);		\LINK BACK
BOX(HASH):=NOSYM;
NOSYM:=NOSYM+1;
end;	\INSERT


proc	GETCON;	\GET A CONSTANT--EITHER BY VALUE OR BY NAME
int	NEG;
begin
if ATOM=^+ then RATOM;
if ATOM=^- then [NEG:=true; RATOM] else NEG:=false;
case ATYPE of
INTCON:	[if NEG then IATOM:=-IATOM];
IDENTIFIER:
	begin
	LOOKUP;
	case IDTYPE of
	INCON:	[IATOM:=if NEG then -VAL else VAL]
	other	ERROR(42);
	end
other	ERROR(42);
end;	\GETCON


proc	CONEXPRESS;	\EVALUATE CONSTANT EXPRESSIONS
\OUTPUTS IATOM
int	ITEMP,IFVAR;

	proc	CFACTOR;
	begin
	if ATOM=^( then
		begin
		RATOM;
		CONEXPRESS;
		if ATOM#^) then ERROR(44);
		end
	else GETCON;
	RATOM;
	end;	\CFACTOR

	proc	CSHIFTEXP;
	int	ITEMP;
	begin
	CFACTOR;
	ITEMP:=IATOM;
	case ATOM of
	LSLSYM:	begin
		RATOM;
		CFACTOR;
		IATOM:=ITEMP << IATOM;
		end;
	LSRSYM:	begin
		RATOM;
		CFACTOR;
		IATOM:=ITEMP >> IATOM;
		end;
	ASRSYM:	begin
		RATOM;
		CFACTOR;
		IATOM:=ITEMP ->> IATOM;
		end
	other;
	end;	\CSHIFTEXP

	proc	CTERM;
	int	ITEMP;
	begin
	CSHIFTEXP;
	loop	begin
		ITEMP:=IATOM;
		case ATOM of
		  ^*:	begin
			RATOM;
			CSHIFTEXP;
			IATOM:=ITEMP * IATOM;
			end;
		  ^/:	begin
			RATOM;
			CSHIFTEXP;
			if IATOM=0 then ERROR(73)
			else IATOM:=ITEMP / IATOM;
			end
		other	quit;
		end;
	end;	\CTERM

	proc	CALGEXP;	\ALGEBRIAC EXPRESSION
	int	ITEMP;
	begin
	CTERM;
	loop	begin
		ITEMP:=IATOM;
		case ATOM of
		  ^+:	begin
			RATOM;
			CTERM;
			IATOM:=ITEMP + IATOM;
			end;
		  ^-:	begin
			RATOM;
			CTERM;
			IATOM:=ITEMP - IATOM;
			end
		other	quit;
		end;
	end;	\CALGEXP

	proc	CLOGEXP;	\'NOT' AND COMPARISONS
	int	ITEMP;
	begin
	if ATOM=NOTSYM ! ATOM=^~ then
		begin
		RATOM;
		CLOGEXP;
		IATOM:= ~IATOM;
		end
	else	begin
		CALGEXP;
		ITEMP:=IATOM;
		case ATOM of
		 ^=:	[RATOM;
			CALGEXP;
			IATOM:= ITEMP = IATOM];
		 ^#:	[RATOM;
			CALGEXP;
			IATOM:= ITEMP # IATOM];
		 ^>:	[RATOM;
			CALGEXP;
			IATOM:= ITEMP > IATOM];
		 ^<:	[RATOM;
			CALGEXP;
			IATOM:= ITEMP < IATOM];
		 GESYM:	[RATOM;
			CALGEXP;
			IATOM:= ITEMP >= IATOM];
		 LESYM:	[RATOM;
			CALGEXP;
			IATOM:= ITEMP <= IATOM]
		other	[];
		end;
	end;	\CLOGEXP

	proc	CBOOLTERM;	\BOOLEAN "&" EXPRESSIONS
	int	ITEMP;
	begin
	CLOGEXP;
	loop	begin
		ITEMP:=IATOM;
		if ATOM=^& ! ATOM=ANDSYM then
			begin
			RATOM;
			CLOGEXP;
			IATOM:=ITEMP & IATOM;
			end
		else quit;
		end;
	end;	\CBOOLTERM

begin	\CONEXPRESS
if ATOM=IFSYM then		\'IF' EXPRESSION
	begin
	RATOM;
	CONEXPRESS;
	IFVAR:=IATOM;
	if ATOM#THENYM then ERROR(22);
	RATOM;
	CONEXPRESS;
	ITEMP:=IATOM;
	if ATOM#ELSEYM then ERROR(30);
	RATOM;
	CONEXPRESS;
	if IFVAR then IATOM:=ITEMP;
	end
else	begin
	CBOOLTERM;
	loop	begin
		ITEMP:=IATOM;
		case ATOM of
		  ^!, ORSYM:
			begin
			RATOM;
			CBOOLTERM;
			IATOM:=ITEMP ! IATOM;
			end;
		  ^|, XORSYM:
			begin
			RATOM;
			CBOOLTERM;
			IATOM:=ITEMP | IATOM;
			end
		other quit;
		end;
	end;
end;	\CONEXPRESS


fproc	BOOLEXP;


proc	PROCAL;
int	SVAL,SLEV,ARGCNT,SID;
begin
SVAL:=VAL; SLEV:=LEV; SID:=IDTYPE;
RATOM;
ARGCNT:=0;
if ATOM=^( then
	begin
	repeat	[RATOM;
		BOOLEXP;
		ARGCNT:=ARGCNT+2]
	until ATOM#^,;
	if ATOM#^) then ERROR(44);
	RATOM;
	end;
case of
SID>=INPROC & SID<=INFPROC:	\NORMAL PROCEDURE CALL
	[if ARGCNT>0 then GEN(\ARG\10,0,ARGCNT-1,2);
	GEN(\CAL\5,SLEV+2,SVAL,15)]
other case SID of
ININT:
	[if SVAL=(12+CODOFF) & STRTERM=0 then
		SVAL:=46+CODOFF; \USE ALTERNATE TEXT0 INTRINSIC
	GEN(\CML\12,0,SVAL,2)];
INOPT:				\OPTIMIZED PROCEDURE CALL
	[if ARGCNT>0 then ERROR(51); \NO ARGS DECLARED
	GEN(\JSR\38,0,SVAL,7)];
INEXT:	GEN(\ECL\41,0,SVAL,3)	\EXTERNAL ASSEMBLY PROCEDURE CALL
other;
end;	\PROCAL


proc	BOOLEXP;	\BOOLEAN EXPRESSION
\OUTPUTS FACTOR TYPE (FACTYP)
int	P1,P2;


proc	FACTOR;


func	STRCON;		\STRING CONSTANT FUNCTION
int	SPC,SCHAR;
begin
SPC:=PC;
CRLF(BINDEV); CHOUT(BINDEV,^;); HEXW(PC);
while CHAR#^" do
	begin			\(GETCH--OPTIMIZED FOR SPEED)
	case CHAR of
	  ^^:	begin
		CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
		if CHAR>=^@ & CHAR<=^_ & CHAR#^^ then CHAR:=CHAR-^@;
		if CHAR>=^` & CHAR<=^~ then CHAR:=CHAR-^`;
		end;
	  EOF: ERROR(63)
	other	[];
	HEXB(CHAR); PC:=PC+1;
	SCHAR:=CHAR;
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	end;
if STRTERM then
	[CRLF(BINDEV); CHOUT(BINDEV,^;); HEXW(PC-1);
	HEXB(SCHAR!$80)]
else	[HEXB(0); PC:=PC+1];
GETCH;
return SPC;	\RETURN STARTING ADDRESS OF STRING
end;	\STRCON

proc	ARRAYCON;	\CONSTANT ARRAYS
int	THISEL,NEXTEL,PNTR,SPC,I,INDIRECT;
def	NULL=$FFFF;
char	ENTRY,R;

	proc ARRAYX;	\(THIS MUST BE AN OPTIMIZED PROCEDURE
	begin		\ FOR THE RESERVE TO WORK PROPERLY.)
	RATOM;
	INDIRECT:=true;
	case ATOM of
	  ^[:	[ENTRY:=ARRAYCON; RATOM];
	  ^":	[ENTRY:=STRCON; RATOM]
	other	begin
		INDIRECT:=false;
		CONEXPRESS;
		ENTRY:=IATOM
		end;

	NEXTEL:=RESERVE(6);
	THISEL(1):=ENTRY;
	THISEL(2):=INDIRECT;
	THISEL(0):=NEXTEL;
	NEXTEL(0):=NULL;
	THISEL:=NEXTEL;
	end;

begin	\ARRAYCON
PNTR:=RESERVE(6);
THISEL:=PNTR;
THISEL(0):=NULL;
ARRAYX;
while ATOM=^, do
	ARRAYX;
if ATOM#^] then ERROR(50);
SPC:=PC;
CRLF(BINDEV); CHOUT(BINDEV,^;); HEXW(PC);
while PNTR(0)#NULL do		\DUMP LIST
	begin
	ENTRY:=PNTR(1);
		begin
		if PNTR(2) \INDIRECT\ then
			[CHOUT(BINDEV,^*); HEXW(ENTRY)]
		else	[HEXB(ENTRY); HEXB(SWAP(ENTRY))];
		PC:=PC+2;
		end;
	PNTR:=PNTR(0);
	end;
return SPC;	\RETURN STARTING ADDRESS OF ARRAY
end;	\ARRAYCON


proc	SPECFAC;	\SPECIAL CHARACTER FACTOR
int	SVAL, SPC, R, SID, SATOM;
begin
case ATOM of
  ^(:	[RATOM;				\PARENTHESIZED EXPRESSION
	BOOLEXP;			\(FACTOR TYPE IS UNCHANGED)
	if ATOM#^) then ERROR(44);
	RATOM];

  ^":	[SPC:=PC;		\STRING CONSTANT
	GEN(\JMP\7,0,0,7);
	SVAL:=STRCON;
	FIX(SPC);
	GEN(\IMM\11,0,SVAL,7);
	RATOM];

  ^[:	[SPC:=PC;		\CONSTANT ARRAY
	GEN(\JMP\7,0,0,7);
	SVAL:=ARRAYCON;
	FIX(SPC);
	GEN(\IMM\11,0,SVAL,7);
	RATOM];

  ADRSYM, ^@:
	begin				\GET ABSOLUTE HEAP ADDRESS
	SATOM:=ATOM;
	RATOM;
	if ATYPE#IDENTIFIER then ERROR(45);
	LOOKUP;
	case IDTYPE of
	  INVAR, ADDRVAR:
		begin
		SID:= IDTYPE;
		RATOM;
		if ATOM=^( then			\INDEXED
			begin
			GEN(\LOD\1,LEV,VAL,10);	\(EVEN FOR REALS)
			RATOM;
			BOOLEXP;		\1ST INDEX
			while ATOM=^, do	\MULTIPLE INDEXING
				begin
				case SID of
				  INVAR, ADDRVAR: GEN(\DBX\$20,0,0,0)
				other [];
				RATOM;
				BOOLEXP;
				end;
			case SID of
			  INVAR: GEN(\DBA\$1E,0,0,0);
			  ADDRVAR: GEN(\ADD\$0D,0,0,0)
			other [];
			if ATOM#^) then ERROR(44) else RATOM;
			end
		else	begin
			GEN(\ADR\$21,LEV,VAL,10);
			end;
		end;
	  UNDEF:	ERROR(10)
	other		ERROR(43);
	end;

  PORTYM:
	begin		\READ BYTE FROM PORT
	RATOM;
	if ATOM#^( then ERROR(39) else RATOM;
	BOOLEXP;
	GEN(\CML\12,0,\PIN\63+CODOFF,2);
	if ATOM#^) then ERROR(44) else RATOM;
	end
other	ERROR(26);
end;	\SPECFAC


proc	IDFAC;		\IDENTIFIER FACTOR
int	SLEV,SVAL,SID,SSN,DIMS;
begin	\IDFAC
LOOKUP;

SID:=IDTYPE;

case IDTYPE of
UNDEF:ERROR(10);

INVAR, ADDRVAR:		\VARIABLE
	begin
	GEN(\LOD\$01,LEV,VAL,10);
	RATOM;
	if ATOM=^( then				\IT IS INDEXED
		begin
		loop	begin
			RATOM;
			BOOLEXP;
			if ATOM#^, then quit;
			GEN(\DBX\$20,0,0,0)
			end;
		if ATOM#^) then ERROR(44) else RATOM;
		case SID of
		 INVAR:   GEN(\DBX\$20,0,0,0);
		 ADDRVAR: GEN(\LDX\$02,0,0,0)
		other	[];
		end;
	end;


INCON:
	begin \CONSTANT
	GENIMM(VAL);
	RATOM;
	end

 other	\PROCEDURES USED AS FUNCTIONS (BY DEFAULT)
	begin
	PROCAL;
	if SID<=INOPT then GEN(\LOD\1,0,0,10);
	end
end;	\IDFAC


begin	\FACTOR
while ATOM=^+ do RATOM;		\IGNORE UNARY "+"
if ATOM=^- then			\UNARY "-"
	[RATOM;
	FACTOR;
	GEN(\NEG\17,0,0,0)]
else
        case ATYPE of
	SPECIAL:SPECFAC;
	INTCON:
	    begin		\LITERAL INTEGER CONSTANT
	    GENIMM(IATOM);
	    RATOM;
	    end
	 other	IDFAC;
end;	\FACTOR


proc	SHIFTEXP;
begin
FACTOR;
case ATOM of
  LSLSYM: [RATOM; FACTOR; GEN(\LSL\$3E,0,0,0)];	\<<
  LSRSYM: [RATOM; FACTOR; GEN(\LSR\$3F,0,0,0)];	\>>
  ASRSYM: [RATOM; FACTOR; GEN(\ASR\$3D,0,0,0)]	\->>
other;
end;	\SHIFTEXP


proc	TERM;

begin
SHIFTEXP;
loop	case ATOM of
	  ^*:	[RATOM; SHIFTEXP; GEN(\MUL\15,0,0,0)];
	  ^/:	[RATOM; SHIFTEXP; GEN(\DIV\16,0,0,0)]
	other	quit;
end;	\TERM


proc	ALGEXP;		\ALGEBRIAC EXPRESSION
begin	\ALGEXP
TERM;
loop	case ATOM of
	  ^+:	[RATOM; TERM; GEN(\ADD\13,0,0,0)];
	  ^-:	[RATOM; TERM; GEN(\SUB\14,0,0,0)]
	other	quit;
end;	\ALGEXP


proc	LOGEXP;		\LOGICAL EXPRESSION

	proc	LOGX; int INOP;
	[RATOM; ALGEXP;	GEN(INOP,0,0,0)];

begin	\LOGEXP
if ATOM=NOTSYM ! ATOM=^~ then		\UNARY 'NOT' OPERATOR
	[RATOM;
\**	if ATOM=NOTSYM ! ATOM=^~ then WARNING(7);
	LOGEXP;
	GEN(\NOT\28,0,0,0)]
else	[ALGEXP;
	case ATOM of
	 ^=:	LOGX(\EQ\18);
	 ^#:	LOGX(\NE\19);
	 ^>:	LOGX(\GT\21);
	 ^<:	LOGX(\LT\23);
	 GESYM:	LOGX(\GE\20);
	 LESYM:	LOGX(\LE\22)
	other;	];
end;	\LOGEXP


proc	BOOLTERM;	\BOOLEAN "&" EXPRESSIONS
begin
LOGEXP;
loop	begin
	if ATOM=^& ! ATOM=ANDSYM then
		[RATOM; LOGEXP; GEN(\AND\27,0,0,0)]
	else	quit;
	end;
end;	\BOOLTERM


begin	\BOOLEXP
if ATOM=IFSYM then			\'IF' EXPRESSION
	[RATOM;	BOOLEXP;
	P1:=PC; GEN(\JPC\8,0,0,7);
	if ATOM#THENYM then ERROR(22);
	RATOM; BOOLEXP;
	if ATOM#ELSEYM then ERROR(30);
	P2:=PC; GEN(\JMP\7,0,0,7); FIX(P1);
	RATOM; BOOLEXP;
	FIX(P2);]
else	begin		\BOOLEAN "!" (OR) AND "|" (XOR) EXPRESSIONS
	BOOLTERM;
	loop	case ATOM of
		  ^!, ORSYM:	[RATOM; BOOLTERM; GEN(\OR\$1A,0,0,0)];
		  ^|, XORSYM:	[RATOM; BOOLTERM; GEN(\EOR\$1D,0,0,0)]
		other quit;
	end;
end;	\BOOLEXP

\----------------------------------------------------------------------

proc	SSTATEMENT; int SSTK;	\(FOR 'QUIT'S IN 'CASE' STMNTS)


proc	STATEMENT;
int	P2,P3,SFIXS,SLEV,SVAL,I,DOWNTO;


proc	ASSIGN;		\ASSIGNMENT STATEMENT
int	SID;
\ (ALSO INCLUDES PROCEDURE CALLS)

	proc	ASSX;
	[if ATOM#GETSYM then ERROR(21);
	RATOM;
	BOOLEXP];	\RIGHT-HAND SIDE OF ASSIGNMENT

begin \ASSIGN
if ATOM=PORTYM then	\port($123):= boolexp
	begin
	RATOM;
	if ATOM#^( then ERROR(39) else RATOM;
	BOOLEXP;
	if ATOM#^) then ERROR(44) else RATOM;
	ASSX;
	GEN(\CML\12,0,\POUT\62+CODOFF,2);
	return;
	end;
if ATYPE#IDENTIFIER then ERROR(20);
LOOKUP;
if IDTYPE=UNDEF then ERROR(10);
SLEV:=LEV; SVAL:=VAL;	\SAVE THESE FOR "GEN." AN INTERIM
SID:=IDTYPE;		\ BOOLEXP MAY CHANGE LEV & VAL

case of
IDTYPE>=INPROC & IDTYPE<=INEXT: PROCAL;

IDTYPE=INVAR ! IDTYPE=ADDRVAR:
	begin
	RATOM;
	if ATOM=^( then			\INDEXED
		begin
		GEN(\LOD\1,SLEV,SVAL,10);
		RATOM;
		BOOLEXP;		\1ST INDEX
		while ATOM=^, do	\MULTIPLE INDEXING
			begin
			GEN(\DBX\$20,0,0,0);
			RATOM;
			BOOLEXP;
			end;
		if ATOM#^) then ERROR(44) else RATOM;
		case SID of
		 INVAR:   GEN(\DBA\$1E,0,0,0);
		 ADDRVAR: GEN(\ADD\$0D,0,0,0)
		other	[];

		ASSX;			\TOS NOW POINTS TO ARRAY ELEMENT
		case SID of
		 INVAR:   GEN(\STD\$1F,0,0,0);
		 ADDRVAR: GEN(\STX\$04,0,0,0)
		other	[];
		end

	else	[ASSX;
		GEN(\STO\$03,SLEV,SVAL,10)];
	end

         other ERROR(21);

end;	\ASSIGN


proc	CASER; int TYPE;
int	SPC1,SPC2,SPC3;


proc	CASER2;
begin
RATOM;
BOOLEXP;
SPC1:=PC;
GEN(TYPE,0,0,7);
if ATOM=^, then				\MULTIPLE LABELS
	[SPC3:=PC;
	repeat	RATOM;	\FOR MORE THAN 2 LABELS
		GEN(\JMP\7,0,SPC3,7);	\2 JUMPS TO STATEMENT
		FIX(SPC1);
		BOOLEXP;
		SPC1:=PC;
		GEN(TYPE,0,0,7);
	until ATOM#^,;
	FIX(SPC3)];
if ATOM#^: then ERROR(49);
RATOM;
STATEMENT;
end;	\CASER2


begin	\CASER
CASER2;
SPC2:=PC;
GEN(\JMP\7,0,0,7);		\JUMP OUT OF CASE STATEMENT
FIX(SPC1);
while ATOM=^; do
	[CASER2;
	GEN(\JMP\7,0,SPC2,7);	\2 JUMP EXIT (BACK THEN OUT)
	FIX(SPC1)];
if ATOM#ELSEYM & ATOM#OTHSYM then ERROR(29);
\**if ATOM=ELSEYM then WARNING(4);
RATOM;
STATEMENT;
FIX(SPC2);
end;	\CASER


begin	\STATEMENT
case ATOM of
BEGSYM,^[:
	begin
	RATOM;
	loop	begin
		if ATOM=ELSEYM then ERROR(52);
		if ATOM=OTHSYM then ERROR(53);
		STATEMENT;
		case ATOM of
		 ^;:	RATOM;
		 ENDSYM:quit;
		 ^]:	quit;
		 EOF:	ERROR(62)
		other	ERROR(41);
		end;
	RATOM;		\READ PAST THE 'END'
	end;
CASEYM:	begin				\CASE STATEMENT
	RATOM;
	if ATOM=OFSYM then CASER(\JPC\8)
	else	begin
		BOOLEXP;
		if ATOM#OFSYM then ERROR(48);
		STKLOD:=STKLOD+1;
		CASER(\CJP\37);
		GEN(\DRP\40,0,0,0);
		STKLOD:=STKLOD-1;
		end;
	end;
QUITYM:	begin
	for I:=SSTK,STKLOD-1 do GEN(\DRP\40,0,0,0);
	if FIXCNT>=QUITMAX then ERROR(4);
	FIXES(FIXCNT):=PC;		\QUIT STATEMENT
	FIXCNT:=FIXCNT+1;
	GEN(\JMP\7,0,0,7);   \(WILL BE "FIXED" AT END OF 'LOOP')
	RATOM;
	end;
IFSYM:	begin				\IF STATEMENT
	RATOM;
	BOOLEXP;
	P3:=PC;
	GEN(\JPC\8,0,0,7);
	if ATOM#THENYM then ERROR(22);
	RATOM;
	STATEMENT;
	if ATOM=ELSEYM then
		[P2:=PC;
		GEN(\JMP\7,0,0,7);
		FIX(P3);
		P3:=P2;
		RATOM;
		STATEMENT];
	FIX(P3);
	end;
REPSYM:	[P2:=PC;			\REPEAT STATEMENT
	repeat RATOM; STATEMENT until ATOM#^;;
	if ATOM#UNTSYM then ERROR(28);
	RATOM;
	BOOLEXP;
	GEN(\JPC\8,0,P2,7)];
WHILYM:	[RATOM;				\WHILE STATEMENT
	P2:=PC;
	BOOLEXP;
	P3:=PC;
	GEN(\JPC\8,0,0,7);
	if ATOM#DOSYM then ERROR(23);
	RATOM;
	STATEMENT;
	GEN(\JMP\7,0,P2,7);
	FIX(P3)];
RETSYM:	begin				\RETURN STATEMENT
	RATOM;
	for I:=0,STKLOD-1 do GEN(\DRP\40,0,0,0);
	if ATOM#ELSEYM & ATOM#OTHSYM & ATOM#^; & ATOM#^] &
	    ATOM#ENDSYM & ATOM#UNTSYM then	\STORE THE RETURNED
		[BOOLEXP;		\ VALUE IN GLOBAL #0
		GEN(\STO\3,0,0,10)];
	GEN(if OPTPROC then \RTS\39 else \RET\6,0,0,0);
	end;
LOOPYM:	begin				\LOOP STATEMENT
	SFIXS:=FIXCNT;
	RATOM;
	P2:=PC;
	SSTATEMENT(STKLOD);
	GEN(\JMP\7,0,P2,7);
	while FIXCNT>SFIXS do	\FIX THE JUMPS FOR THE 'QUIT'S
		[FIXCNT:=FIXCNT-1; FIX(FIXES(FIXCNT))];
	end;
FORSYM:	begin				\FOR STATEMENT
	RATOM;
	if ATYPE#IDENTIFIER then ERROR(33);
	LOOKUP;
	if IDTYPE=UNDEF then ERROR(10)
	else	if IDTYPE#INVAR & IDTYPE#ADDRVAR then ERROR(43);
	SLEV:=LEV; SVAL:=VAL;
	RATOM;
	if ATOM#GETSYM then ERROR(21);
	RATOM;
	BOOLEXP;
	GEN(\STO\3,SLEV,SVAL,10);

	DOWNTO:= false;
	if ATOM=TOSYM ! ATOM=^, then []
	else if ATOM=DOWNYM then DOWNTO:= true
	else ERROR(24);

	RATOM;
	BOOLEXP;
	if ATOM#DOSYM then ERROR(23);
	GEN(\LOD\1,SLEV,SVAL,10);
	P2:=PC;
	GEN(if DOWNTO then \FORD\$49 else \FOR\24, 0, 0, 7);
	RATOM;
	STKLOD:=STKLOD+1;
	STATEMENT;
	STKLOD:=STKLOD-1;
	GEN(if DOWNTO then \DEC\$4A else \INC\25, SLEV, SVAL, 10);
	GEN(\JMP\7,0,P2,7);
	FIX(P2);
	\NOTE: THE INTERPRETER SPEEDS UP THINGS BY ASSUMING THAT "INC" OR "DEC"
	\ WILL ALWAYS BE FOLLOWED BY A "JMP" GOING BACK TO THE "FOR"
	end;
EXITYM:	[RATOM;				\EXIT STATEMENT
	if ATOM#ELSEYM & ATOM#OTHSYM & ATOM#^; & ATOM#^] &
	    ATOM#ENDSYM & ATOM#UNTSYM then	\STORE THE RETURNED
		[BOOLEXP;			\ VALUE IN GLOBAL #0
		GEN(\STO\3,0,0,10)];
	GEN(\EXT\0,0,0,0)];
ELSEYM:	[];				\NULL STATEMENT
OTHSYM:	[];
^;:	[];
^]:	[];
ENDSYM:	[];
UNTSYM:	[];
EOF:	[]		\(THIS IS MOSTLY AN ACADEMIC POINT)
other	ASSIGN;
end;	\STATEMENT


begin	\SSTATEMENT
\TRICK TO ADJUST STACK (WITH DRP'S) WHEN A 'QUIT' IS IN
\ A 'CASE' STATEMENT.
STATEMENT;
end;	\SSTATEMENT

\----------------------------------------------------------------------

proc	PROCEDURE; int SSNOX;	\"SSNO" FROM "PROCDEC" FOR OPTIMIZED PROCS
int	SLEVEL,		\SAVE LEVEL (COMPLICATED BY OPTIMIZED PROCEDURES)
	P1,DX,		\HEAP SPACE REQUIREMENT COUNTER, unsigned
	DXOFF,		\VARIABLE'S OFFSET FROM BASE, unsigned
	FPBASE,		\PC AT END OF DECLARATIONS
	FPROCNT;	\COUNT OF PENDING FORWARD PROCEDURES


proc	EATARGS;	\SKIP ARGUMENTS IN PARENTHESIS
begin
if ATOM=^( then
	begin
	loop	[if CHAR=^) then quit;
		if CHAR=$0D\CR\ then [ERROR(44); quit];
		GETCH];
	GETCH; RATOM;
	end;
end;	\EATARGS


proc	CODDEC;		\DECLARE INTRINSIC NAMES
int	SID;
begin
SID:=ININT;		\DEFAULT IS INTEGER INTRINSIC
RATOM;
if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	EATARGS;
	if ATOM#^= then ERROR(40);
	RATOM;
	GETCON;
	if IATOM<0 ! IATOM>=CODOFF then ERROR(7);
	INSERT(SID,LEVEL,IATOM+CODOFF);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\CODDEC


proc	CONDEC;		\DECLARE CONSTANT NAMES
int	CNTR,SSNO;
begin
RATOM;
CNTR:=0;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	begin
	RATOM;
	if ATOM#^= then [INSERT(INCON,LEVEL,CNTR); CNTR:=CNTR+1]
	else	begin
		SSNO:=NOSYM;
		INSERT(INCON,LEVEL,IATOM);	\INSERT ID NOW
		RATOM;				\ FIX UP PARMS LATER
		CONEXPRESS;
		SYMVAL(SSNO):=IATOM; CNTR:= IATOM+1;
		end;
	if ATOM=^, then RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\CONDEC


proc	VARDEC; int TYPE;  \DECLARE VARIABLES--INT, ADDR
int	SDX,DIMS,T,ST,SNS;
begin
RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
OPTPROC:=false;
while ATYPE=IDENTIFIER do
	begin
        SNS:= NOSYM;
	INSERT(TYPE,LEVEL,DXOFF);
	SDX:=DXOFF;
	DXOFF:=DXOFF+2;
	DX:=DX+2;
	T:=2;
	ST:= T;
	if TYPE=ADDRVAR then ST:=1;
	RATOM;
	if ATOM=^( then		\GET DIMENSIONS OF AN ARRAY
		begin
		if DX#0 then [GEN(\HPI\9,0,DX,3); DX:=0];
		DIMS:= 0;
		loop	begin
			RATOM;
			CONEXPRESS;
			\PUSH SIZES OF EACH DIMENSION ON STACK
			GENIMM(IATOM);
			DIMS:= DIMS+1;
			if ATOM # ^, then	\last dimension of char array is
				begin		\ only a single byte per entry
				if ST=1 then T:=T>>1;
				T:=T*IATOM;
				DXOFF:=DXOFF+T;
				quit;
				end;
			T:=T*IATOM;    \ACCUMULATE BYTE COUNT FOR EACH DIMENSION
			DXOFF:=DXOFF+T;	\OFFSET FROM BASE
			end;
		if ATOM#^) then ERROR(44) else RATOM;
		\GEN CODE TO SET UP ARRAY AT RUN TIME
		\GEN CALL MakeArray([3, 5, 7, 10], 4, 2, addr ArrayName);
		GENIMM(DIMS);		\NUMBER OF DIMENSIONS
		GENIMM(ST);		\NUMBER OF BYTES IN EACH ELEMENT
		GEN(\ADR\33,LEVEL,SDX,10); \ADDRESS OF POINTER TO ARRAY
		GEN(\ARY\$3C,0,0,0);
		end;
	if ATOM=^, then RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\VARDEC


proc	EXTDEC;
begin
RATOM;
if ATOM=INTSYM then RATOM;
while ATYPE=IDENTIFIER do
	begin
	RATOM;
	EATARGS;
	if ATOM#^= then ERROR(40);
	RATOM;
	GETCON;
	INSERT(INEXT,0,IATOM);
	RATOM;
	if ATOM=^, then RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\EXTDEC


proc	FPRDEC; int OPTYPE;	\DECLARE FORWARD REFERENCED PROCEDURES
int	SID;
begin
SID:=INFPROC;		\DEFAULT IS INTEGER FORWARD PROCEDURE
RATOM;
if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	INSERT(SID,LEVEL,PC);
	GEN(\JMP\7,0,PC,OPTYPE);
	FPROCNT:=FPROCNT+1;
	EATARGS;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\FPRDEC


proc	PROCDEC; int CANOPT\**,PUBLIC\;		\DECLARE PROCEDURE NAMES
int	SNOSYM,HASH,I,K,SID,SSNO\**,SNORL\;
begin
SID:=INPROC;			\TYPED PROCEDURE (FOR FUNCTIONS)
RATOM;
if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45) else LOOKUP;
if IDTYPE=INFPROC then
	\PROCEDURE HAS BEEN PREVIOUSLY DECLARED BY A 'FPROC' OR 'FFUNCT'
	[if LEVEL#LEV then ERROR(65);
	FIX(VAL);	\('FPROC' & 'PROC' MUST BE SAME SCOPE)
	SYMVAL(SYMNUM):=PC;
	SYMTYP(SYMNUM):=INPROC;
	if VAL>=FPBASE then FPROCNT:=FPROCNT-1;
	OPTPROC:=false]
else [SSNO:=NOSYM; INSERT(SID,LEVEL,PC); OPTPROC:=CANOPT];

\HANDLE PUBLIC PROCEDURES
\**if PUBLIC then [CHOUT(BINDEV,^%); SYMOUT(NOSYM-1)];\

\ASSUME FOR NOW THAT PROCEDURE IS NOT OPTIMIZED AND MOVE DOWN A LEVEL
SLEVEL:=LEVEL;
LEVEL:=LEVEL+2; if LEVEL>14 then ERROR(5);
					\EAT THE ARGUMENT LIST AS A COMMENT
while CHAR#^; & CHAR#\CR\$0D do GETCH;	\SPECIAL COMMENT STOPS ON CR
if CHAR#^; then ERROR(41);

GETCH; RATOM;

SNOSYM:=NOSYM; \**SNORL:=NORLSY;\
PROCEDURE(SSNO);	\PASS LOCATION OF PROC NAME IN CASE IT'S OPTIMIZED
\**CHKUSE(SNOSYM);\
if ATOM#^; then ERROR(41) else RATOM;

while NOSYM>SNOSYM do	\RESTORE SYMBOL TABLE TO PREVIOUS LEVEL
\I.E. REMOVE THE IDENTIFIERS WHICH WERE LOCAL TO THIS PROCEDURE
	begin
	NOSYM:=NOSYM-1;
	HASH:=0;
	K:=NOSYM;
	for I:=0,SIGCHAR-1 do
		[HASH:=HASH+SYMBOL(K); K:=K+SYMAX];
	BOX(HASH&HASHMSK):=SYMPNT(NOSYM);
	end;
\**NORLSY:=SNORL;\
LEVEL:=SLEVEL;
end;	\PROCDEC


begin	\PROCEDURE
DXOFF:= if LEVEL=0 then 2 else 0; \SAVE HEAP SPACE FOR GLOBAL 0
DX:= DXOFF;

repeat
   loop case ATOM of
	INTSYM:VARDEC(INVAR);
	ADRSYM:VARDEC(ADDRVAR);
	CHARYM:VARDEC(ADDRVAR);
	CODSYM:CODDEC;
	EXTNYM:EXTDEC;
	DEFSYM:CONDEC
	 other quit;

   P1:=PC;
   GEN(\JMP\7,0,0,7);

   FPROCNT:=0;
   FPBASE:=PC;
   loop case ATOM of
	PROCYM, FUNSYM:PROCDEC(true);
	FPRSYM, FFUNYM:FPRDEC(7)
	other quit;

   \IF THERE IS NOTHING TO JUMP OVER THEN ELIMINATE THE JUMP
   if PC=P1+3 then PC:=P1 else FIX(P1);

until	ATOM#INTSYM & ATOM#ADRSYM & ATOM#CHARYM  & ATOM#CODSYM &
	ATOM#EXTNYM & ATOM#DEFSYM;

\RESERVE SPACE FOR LOCAL VARIABLES
if DXOFF#0 then		\note that a dimensioned array can make DX # DXOFF
	[OPTPROC:=false;
	if DX#0 then GEN(\HPI\9,0,DX,3)];
if OPTPROC then
	[SYMTYP(SSNOX):= INOPT;
	LEVEL:=LEVEL-2];	\SAME LEVEL AS NESTING PROCEDURE (TRICKY!)

SSTATEMENT(STKLOD);	\(STKLOD WILL ALWAYS BE ZERO HERE)

GEN(if OPTPROC then \RTS\39 else \RET\6,0,0,0);

if FIXCNT#0 then ERROR(60);
if FPROCNT#0 then ERROR(66);
end;	\PROCEDURE

\%%% ROUTINES TO OPEN IBM FILES %%%

proc	IBMOPEN;
int	PSEG,CSEG;
addres TAIL,TLEN;

	proc	MAKUP(C);
	\CONVERT C TO UPPERCASE
	int	C;
	return if C>=^a & C<=^z then C-32 else C;

	proc	GETSWT;
	\FIND, REMOVE AND RETURN SWITCH
	int	P,T;
	begin
	for P:=0,TLEN(0) do if TAIL(P)=^/ then
		begin
		TAIL(P):=$20;
		if P<TLEN(0) then
			begin
			T:=TAIL(P+1);
			TAIL(P+1):=$20;
			return MAKUP(T);
			end;
		end;
	return 0;
	end;

	proc	PARSE;
	\PARSE COMMAND TAIL AND SET I/O HANDLES
	address EXT1,EXT2;
	int	P,EFLG,I;
	begin
	EXT1:=".XPL";EXT2:=".I2L";

	P:=0;
	EFLG:=false;
	\PARSE COMMAND TAIL FOR EXTENTION

	loop
		begin
		if TAIL(P)=^. then
			begin
			EFLG:=true;
			quit;
			end;
		P:=P+1;
		if P>=TLEN(0) then
			begin
			EFLG:=false;
			quit;
			end;
		end;

	\SET EXTENTION AND INPUT HANDLE
	if not EFLG then
		for I:=0,3 do TAIL(P+I):=EXT1(I);
	INHAND:=FOPEN(TAIL,0);

	\SET EXTENTION AND OUTPUT HANDLE
	for I:=0,3 do TAIL(P+I):=EXT2(I);
	OUTHAND:=FOPEN(TAIL,1);
	end;

begin	\OF IBMOPEN

\GET COMMAND TAIL FROM PSP
TLEN:=RESERVE(80);
TAIL:=TLEN+1;
SYSINF:=GETREG;
PSEG:=SYSINF(11);
CSEG:=SYSINF(12);
BLIT(PSEG,$80,CSEG,TLEN,79);
if TLEN(0)>79 then TLEN(0):=79;

\LIST TO SCREEN IF "/L" SWITCH
if GETSWT=^L then DEVICE(1):=0;

\PARSE COMMAND LINE AND SET HANDLES
PARSE;

\%OPEN FILES
FSET(INHAND,^I);
FSET(OUTHAND,^O);
end;

begin \MAIN PROGRAM\

\INITIALISE IO DEVICES
OPENI(0);OPENO(0);
CRLF(0);
TEXT(0,"XPL0 (C) 1980");
TEXT(0,"  PC XCOMPILER  VER 1.0  2015-12-07 ");

\RESERVE ARRAYS\
IDENT:=RESERVE(SIGCHAR);
SYMBOL:=RESERVE(SYMAX*SIGCHAR);
SYMTYP:=RESERVE(SYMAX);
SYMVAL:=RESERVE(SYMAX*2);
SYMLEV:=RESERVE(SYMAX);
SYMPNT:=RESERVE(SYMAX*2);
BOX:=RESERVE(BOXNUM*2);
FIXES:=RESERVE(QUITMAX*2);

\loop
\	begin
\	CRLF(0);TEXT(0,"BINARY:");
\	CHOUT(0,if BINDEV=3 then ^Y else ^N);
\	CRLF(0);TEXT(0,"LISTING:");
\	CHOUT(0,if LSTDEV=0 then ^Y else ^N);
\	CRLF(0);TEXT(0,"OK?");
\	OPENI(0);
\	if CHIN(0)#^N then quit;
\	CRLF(0);TEXT(0,"BINARY?");
\	OPENI(0);
\	BINDEV:=if CHIN(0)=^Y then 3 else 7;
\	TEXT(0,"LISTING?");
\	OPENI(0);
\	LSTDEV:=if CHIN(0)=^Y then 0 else 7;
\	end;
\SRCDEV:=3;

\% SET DEFAULT CHANNELS
DEVICE:=[3,8,3];

\% OPEN IBM FILES
IBMOPEN;
BINDEV:=DEVICE(0);LSTDEV:=DEVICE(1);SRCDEV:=DEVICE(2);

OPENO(BINDEV);
OPENO(LSTDEV);
OPENI(SRCDEV);

\PRESET SOME THINGS\
CHAR:=$0D;	CASEIN:=false;
PC:=0; LEVEL:=0;			\INITIALIZE SOME STUFF
OLDPC:=$FFFF; STKLOD:=0; NOSYM:=0; FIXCNT:=0;
for T:=0,BOXNUM-1 do BOX(T):=EMTPTR;	\ZERO THE SYMBOL TABLE
CONDITIONAL:= true;
STRTERM:= -1;		\DEFAULT TO MSB STRING TERMINATION (NONZERO)

GETCH; RATOM;
OPTPROC:=false;		\(FOR 2 REASONS)
for T:=0,SIGCHAR-1 do IDENT(T):=^ ;

PROCEDURE(0);

if ATOM=^; then RATOM;
if ATOM#EOF then ERROR(61);
CHOUT(BINDEV,^$);

CRLF(0);
TEXT(0,"PROGRAM LENGTH: ");
INTOUT(0,PC+1);
CRLF(0);
CLOSE(LSTDEV);
CHOUT(BINDEV,EOF);
CLOSE(BINDEV);

\% CLOSE IBM FILES
FCLOSE(OUTHAND);
FCLOSE(INHAND);

end;	\MAIN

